//+------------------------------------------------------------------+
//|                                                    #MOBIUS_Q.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "  && BLACK_BOX"
#property link      ""
//=================================================================
//=================================================================
#property indicator_separate_window
#property indicator_buffers 7
#property indicator_level1 0
#property indicator_levelcolor Gray
//=====================================================================
#define  CURR_TOTAL 9
#define  PAIRS_NMBR 8
#define USD  0
#define EUR  1
#define GBP  2
#define JPY  3
#define CAD  4
#define AUD  5
#define CHF  6
#define NZD  7
#define XAU  8
//=====================================================================
extern string txt1="---Currency Line Parameters---";
extern int Fast = 3;
extern int Slow = 5;
extern int MA_Method = 3;
extern int Price = 6;
extern int Smooth = 5;
extern int SmoothMethod = 2;
extern string txt2="----Histogram Smothing ----";
extern int Hist_Per_1 = 3;
extern int Method_1 = 3;
extern int Hist_Per_2 = 14;
extern int Method_2 = 3;
extern string txt3="-----Misc----";
extern int ifXAU = 1;
extern int Line_Thickness = 2;
extern int Bars.Count = 2000;
//+-------------------------
//=====================================================================
string Currency[CURR_TOTAL]={"USD","EUR","GBP","JPY","CAD","AUD","CHF","NZD","XAU"};
bool   Include[CURR_TOTAL]={  1  ,  1  ,  1  ,  1  ,  1  ,  1  ,  1  ,  1  ,  1  }; 
int pair[2];
//=================================================================
double    Buffer0[],
          Buffer1[],
          Buffer2[],
          Buffer3[],
          Buffer4[],
          Buffer5[],
          Buffer6[];
//+-------------------------
int Line0 = DRAW_LINE;
int Line1 = DRAW_LINE;
int Line2 = DRAW_HISTOGRAM;
int Histo_Line = DRAW_HISTOGRAM;
int Line3 = DRAW_LINE;
int MaxPer = 20;
int TF = 0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------  
int init()
  {   
    Include[CURR_TOTAL-1]=ifXAU;
    
    color Color[CURR_TOTAL] = {Green,Blue,Crimson,Yellow,DarkSlateBlue,Purple,CadetBlue,Teal,DarkOrange,DarkSlateGray,DarkGray};
    color Color_Line2 = DarkSlateGray;
    color Color_Line3 = DarkGray;
    color Color_Line4 = HotPink;
    string Indicator_Name = WindowExpertName();
    IndicatorShortName(Indicator_Name);
    
    PickOutCurrency(pair);
     
    SetIndexBuffer(0, Buffer0);
    SetIndexStyle (0, Line0, DRAW_LINE, Line_Thickness, Color[pair[0]]);
    SetIndexLabel (0, Currency[pair[0]]);
       
    SetIndexBuffer(1, Buffer1);
    SetIndexStyle (1, Line1, DRAW_LINE, Line_Thickness, Color[pair[1]]);
    SetIndexLabel (1, Currency[pair[1]]);   
    
    SetIndexBuffer(2, Buffer2);
    SetIndexStyle (2, Line2, Histo_Line, 0, Color_Line2);
    SetIndexLabel (2, "Histo");
    
    SetIndexBuffer(3, Buffer3);
    SetIndexStyle (3, Line3, DRAW_LINE, 0, Color_Line3);
    SetIndexLabel (3, "Histo_MA1"); 
    
    SetIndexBuffer(4, Buffer4);
    SetIndexStyle (4, Line3, DRAW_LINE, 0, Color_Line4);
    SetIndexLabel (4, "Histo_MA2"); 
    
    SetIndexBuffer(5, Buffer5);
    SetIndexStyle (5, Line3, DRAW_LINE, Line_Thickness+1, Color[pair[0]]);
    SetIndexLabel (5, "MA_"+ Currency[pair[0]]); 
    
    SetIndexBuffer(6, Buffer6);
    SetIndexStyle (6, Line3, DRAW_LINE, Line_Thickness+1, Color[pair[1]]);
    SetIndexLabel (6, "MA_"+ Currency[pair[1]]); 
    
    MaxPer = Smooth + Hist_Per_1 + Hist_Per_1;
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
  int limit;
  double Result[3];
  int counted_bars = IndicatorCounted();
  
  if (counted_bars<0) return(-1);
  limit=Bars-counted_bars;
  if (Bars.Count>0 && limit>Bars.Count) limit=Bars.Count;
  
  /*if(counted_bars < MaxPer)
  for(int i = 0; i < limit; i++) 
     {
      Buffer0[i] = 0.0;
      Buffer1[i] = 0.0;
      Buffer2[i] = 0.0;
      Buffer3[i] = 0.0;
      Buffer4[i] = 0.0;
      Buffer5[i] = 0.0;
      Buffer6[i] = 0.0;
     }  
   */
//----  
  for(int i = 0; i < limit; i++)
    {
      GetData(Result, pair,TF, i);
      Buffer0[i] = Result[0];
      Buffer1[i] = Result[1];
      Buffer2[i] = Result[2];       
    }
    
  if(counted_bars < MaxPer)
     for(i = 0; i < limit; i++)
         {
          Buffer3[i] = iMAOnArray(Buffer2,Bars,Hist_Per_1,0,Method_1,i);
          Buffer4[i] = iMAOnArray(Buffer2,Bars,Hist_Per_2,0,Method_2,i);
          Buffer5[i] = iMAOnArray(Buffer0,Bars,Smooth,0,SmoothMethod,i);
          Buffer6[i] = iMAOnArray(Buffer1,Bars,Smooth,0,SmoothMethod,i);
         }

  return(0);
}
//+------------------------------------------------------------------+    

//=====================================================================
//+------------------------------------------------------------------+
//|                                              CCFp-Mobius_lib.mq4 |
//|                                                        BLACK_BOX |
//|                                                                  |
//+------------------------------------------------------------------+

//=====================================================================
//**************************************************************************************************
//  ()    
//   
//**************************************************************************************************
int PickOutCurrency(int& pair[2])
{
 for(int i = 0; i < CURR_TOTAL; i++)
   {
      if(StringFind(Symbol(), Currency[i], 0) == 0) pair[0] = i;
      if(StringFind(Symbol(), Currency[i], 3) == 3) pair[1] = i; 
   } 
 return(0);
}            
//**************************************************************************************************
// 
//**************************************************************************************************
int GetData(double& Result[3], int pair[2], int TF, int bar)
{
//-----------------------------------------------------------
//  
//-----------------------------------------------------------
       if(Include[EUR])
         {
           double EURUSD_Fast = ma("EURUSD", TF, Fast, MA_Method, Price, bar);
           double EURUSD_Slow = ma("EURUSD", TF, Slow, MA_Method, Price, bar);
           if(!EURUSD_Fast || !EURUSD_Slow)
           return(0);
         }
       if(Include[GBP])
         {
           double GBPUSD_Fast = ma("GBPUSD", TF, Fast, MA_Method, Price, bar);
           double GBPUSD_Slow = ma("GBPUSD", TF, Slow, MA_Method, Price, bar);
           if(!GBPUSD_Fast || !GBPUSD_Slow)
           return(0);
         }
       if(Include[AUD])
         {
           double AUDUSD_Fast = ma("AUDUSD", TF, Fast, MA_Method, Price, bar);
           double AUDUSD_Slow = ma("AUDUSD", TF, Slow, MA_Method, Price, bar);
           if(!AUDUSD_Fast || !AUDUSD_Slow)
           return(0);
         }
       if(Include[NZD])
         {
           double NZDUSD_Fast = ma("NZDUSD", TF, Fast, MA_Method, Price, bar);
           double NZDUSD_Slow = ma("NZDUSD", TF, Slow, MA_Method, Price, bar);
           if(!NZDUSD_Fast || !NZDUSD_Slow)
           return(0);
         }
       if(Include[CAD])
         {
           double USDCAD_Fast = ma("USDCAD", TF, Fast, MA_Method, Price, bar);
           double USDCAD_Slow = ma("USDCAD", TF, Slow, MA_Method, Price, bar);
           if(!USDCAD_Fast || !USDCAD_Slow)
           return(0);
         }
       if(Include[CHF])
         {
           double USDCHF_Fast = ma("USDCHF", TF, Fast, MA_Method, Price, bar);
           double USDCHF_Slow = ma("USDCHF", TF, Slow, MA_Method, Price, bar);
           if(!USDCHF_Fast || !USDCHF_Slow)
           return(0);
         }
       if(Include[JPY])
         {
           double USDJPY_Fast = ma("USDJPY", TF, Fast, MA_Method, Price, bar);
           double USDJPY_Slow = ma("USDJPY", TF, Slow, MA_Method, Price, bar);
           if(!USDJPY_Fast || !USDJPY_Slow)
           return(0);
         }
       
       if(Include[EUR])
         {
           double XAUUSD_Fast = ma("XAUUSD", TF, Fast, MA_Method, Price, bar);
           double XAUUSD_Slow = ma("XAUUSD", TF, Slow, MA_Method, Price, bar);
           if(!XAUUSD_Fast || !XAUUSD_Slow)
           return(0);
         }  
//-----------------------------------------------------------      
//  
//-----------------------------------------------------------
    for(int i=0; i<2; i++)
      {
       Result[i] = 0;
       switch(pair[i]) 
           {
            case USD :   if(Include[EUR]) Result[i] += EURUSD_Slow / EURUSD_Fast - 1;
                         if(Include[GBP]) Result[i] += GBPUSD_Slow / GBPUSD_Fast - 1;
                         if(Include[AUD]) Result[i] += AUDUSD_Slow / AUDUSD_Fast - 1;
                         if(Include[NZD]) Result[i] += NZDUSD_Slow / NZDUSD_Fast - 1;
                         if(Include[CHF]) Result[i] += USDCHF_Fast / USDCHF_Slow - 1;
                         if(Include[CAD]) Result[i] += USDCAD_Fast / USDCAD_Slow - 1;
                         if(Include[JPY]) Result[i] += USDJPY_Fast / USDJPY_Slow - 1;
                         if(Include[XAU]) Result[i] += XAUUSD_Slow / XAUUSD_Fast - 1; 
                         break;
       
            case EUR  :  if(Include[USD]) Result[i] += EURUSD_Fast / EURUSD_Slow - 1;
                         if(Include[GBP]) Result[i] += (EURUSD_Fast / GBPUSD_Fast)/(EURUSD_Slow/GBPUSD_Slow) - 1;
                         if(Include[AUD]) Result[i] += (EURUSD_Fast / AUDUSD_Fast)/(EURUSD_Slow/AUDUSD_Slow) - 1;
                         if(Include[NZD]) Result[i] += (EURUSD_Fast / NZDUSD_Fast)/(EURUSD_Slow/NZDUSD_Slow) - 1;
                         if(Include[CHF]) Result[i] += (EURUSD_Fast*USDCHF_Fast)/(EURUSD_Slow*USDCHF_Slow) - 1;
                         if(Include[CAD]) Result[i] += (EURUSD_Fast*USDCAD_Fast)/(EURUSD_Slow*USDCAD_Slow) - 1;
                         if(Include[JPY]) Result[i] += (EURUSD_Fast*USDJPY_Fast)/(EURUSD_Slow*USDJPY_Slow) - 1;
                         if(Include[XAU]) Result[i] += (EURUSD_Fast / XAUUSD_Fast)/(EURUSD_Slow/XAUUSD_Slow) - 1;       
                         break;     
            case GBP :
                         if(Include[USD]) Result[i] += GBPUSD_Fast / GBPUSD_Slow - 1;
                         if(Include[EUR]) Result[i] += (EURUSD_Slow / GBPUSD_Slow)/(EURUSD_Fast / GBPUSD_Fast) - 1;
                         if(Include[AUD]) Result[i] += (GBPUSD_Fast / AUDUSD_Fast)/(GBPUSD_Slow / AUDUSD_Slow) - 1;
                         if(Include[NZD]) Result[i] += (GBPUSD_Fast / NZDUSD_Fast)/(GBPUSD_Slow / NZDUSD_Slow) - 1;
                         if(Include[CHF]) Result[i] += (GBPUSD_Fast*USDCHF_Fast)/(GBPUSD_Slow*USDCHF_Slow) - 1;
                         if(Include[CAD]) Result[i] += (GBPUSD_Fast*USDCAD_Fast)/(GBPUSD_Slow*USDCAD_Slow) - 1;
                         if(Include[JPY]) Result[i] += (GBPUSD_Fast*USDJPY_Fast)/(GBPUSD_Slow*USDJPY_Slow) - 1;
                         if(Include[XAU]) Result[i] += (GBPUSD_Fast / XAUUSD_Fast)/(GBPUSD_Slow / XAUUSD_Slow) - 1;                
                         break;   
            case AUD :
                         if(Include[USD]) Result[i] += AUDUSD_Fast / AUDUSD_Slow - 1;
                         if(Include[EUR]) Result[i] += (EURUSD_Slow / AUDUSD_Slow) /(EURUSD_Fast / AUDUSD_Fast) - 1;
                         if(Include[GBP]) Result[i] += (GBPUSD_Slow / AUDUSD_Slow) /(GBPUSD_Fast / AUDUSD_Fast) - 1;
                         if(Include[NZD]) Result[i] += (AUDUSD_Fast/NZDUSD_Fast) / (AUDUSD_Slow / NZDUSD_Slow) - 1;
                         if(Include[CHF]) Result[i] += (AUDUSD_Fast*USDCHF_Fast) / (AUDUSD_Slow*USDCHF_Slow) - 1;
                         if(Include[CAD]) Result[i] += (AUDUSD_Fast*USDCAD_Fast) / (AUDUSD_Slow*USDCAD_Slow) - 1;
                         if(Include[JPY]) Result[i] += (AUDUSD_Fast*USDJPY_Fast) / (AUDUSD_Slow*USDJPY_Slow) - 1;
                         if(Include[XAU]) Result[i] += (AUDUSD_Fast/XAUUSD_Fast) / (AUDUSD_Slow / XAUUSD_Slow) - 1;                 
                         break;   
            case NZD :
                         if(Include[USD]) Result[i] += NZDUSD_Fast / NZDUSD_Slow - 1;
                         if(Include[EUR]) Result[i] += (EURUSD_Slow / NZDUSD_Slow) / (EURUSD_Fast/NZDUSD_Fast) - 1;
                         if(Include[GBP]) Result[i] += (GBPUSD_Slow / NZDUSD_Slow) / (GBPUSD_Fast / NZDUSD_Fast) - 1;
                         if(Include[AUD]) Result[i] += (AUDUSD_Slow / NZDUSD_Slow) / (AUDUSD_Fast / NZDUSD_Fast) - 1;
                         if(Include[CHF]) Result[i] += (NZDUSD_Fast*USDCHF_Fast) / (NZDUSD_Slow*USDCHF_Slow) - 1;
                         if(Include[CAD]) Result[i] += (NZDUSD_Fast*USDCAD_Fast) / (NZDUSD_Slow*USDCAD_Slow) - 1;
                         if(Include[JPY]) Result[i] += (NZDUSD_Fast*USDJPY_Fast) / (NZDUSD_Slow*USDJPY_Slow) - 1;
                         if(Include[XAU]) Result[i] += (XAUUSD_Slow / NZDUSD_Slow) / (XAUUSD_Fast / NZDUSD_Fast) - 1;                 
                         break;   
            case CAD :
                         if(Include[USD]) Result[i] += USDCAD_Slow / USDCAD_Fast - 1;
                         if(Include[EUR]) Result[i] += (EURUSD_Slow*USDCAD_Slow) / (EURUSD_Fast*USDCAD_Fast) - 1;
                         if(Include[GBP]) Result[i] += (GBPUSD_Slow*USDCAD_Slow) / (GBPUSD_Fast*USDCAD_Fast) - 1;
                         if(Include[AUD]) Result[i] += (AUDUSD_Slow*USDCAD_Slow) / (AUDUSD_Fast*USDCAD_Fast) - 1;
                         if(Include[NZD]) Result[i] += (NZDUSD_Slow*USDCAD_Slow) / (NZDUSD_Fast*USDCAD_Fast) - 1;
                         if(Include[CHF]) Result[i] += (USDCHF_Fast / USDCAD_Fast) / (USDCHF_Slow / USDCAD_Slow) - 1;
                         if(Include[JPY]) Result[i] += (USDJPY_Fast / USDCAD_Fast) /(USDJPY_Slow / USDCAD_Slow) - 1;
                         if(Include[XAU]) Result[i] += (XAUUSD_Slow*USDCAD_Slow) / (XAUUSD_Fast*USDCAD_Fast) - 1;                                   
                         break;   
            case CHF :
                         if(Include[USD]) Result[i] += USDCHF_Slow / USDCHF_Fast - 1;
                         if(Include[EUR]) Result[i] += (EURUSD_Slow*USDCHF_Slow) / (EURUSD_Fast*USDCHF_Fast) - 1;
                         if(Include[GBP]) Result[i] += (GBPUSD_Slow*USDCHF_Slow) /(GBPUSD_Fast*USDCHF_Fast) - 1;
                         if(Include[AUD]) Result[i] += (AUDUSD_Slow*USDCHF_Slow) / (AUDUSD_Fast*USDCHF_Fast) - 1;
                         if(Include[NZD]) Result[i] += (NZDUSD_Slow*USDCHF_Slow) / (NZDUSD_Fast*USDCHF_Fast) - 1;
                         if(Include[CAD]) Result[i] += (USDCHF_Slow / USDCAD_Slow) /(USDCHF_Fast / USDCAD_Fast) - 1;
                         if(Include[JPY]) Result[i] += (USDJPY_Fast / USDCHF_Fast) / (USDJPY_Slow / USDCHF_Slow) - 1;
                         if(Include[XAU]) Result[i] += (XAUUSD_Slow*USDCHF_Slow) / (XAUUSD_Fast*USDCHF_Fast) - 1;                 
                         break;   
            case JPY :
                         if(Include[USD]) Result[i] += USDJPY_Slow / USDJPY_Fast - 1;
                         if(Include[EUR]) Result[i] += (EURUSD_Slow*USDJPY_Slow) / (EURUSD_Fast*USDJPY_Fast) - 1;
                         if(Include[GBP]) Result[i] += (GBPUSD_Slow*USDJPY_Slow) / (GBPUSD_Fast*USDJPY_Fast) - 1;
                         if(Include[AUD]) Result[i] += (AUDUSD_Slow*USDJPY_Slow) / (AUDUSD_Fast*USDJPY_Fast) - 1;
                         if(Include[NZD]) Result[i] += (NZDUSD_Slow*USDJPY_Slow) / (NZDUSD_Fast*USDJPY_Fast) - 1;
                         if(Include[CAD]) Result[i] += (USDJPY_Slow/USDCAD_Slow) / (USDJPY_Fast/USDCAD_Fast) - 1;
                         if(Include[CHF]) Result[i] += (USDJPY_Slow/USDCHF_Slow) / (USDJPY_Fast/USDCHF_Fast) - 1;
                         if(Include[XAU]) Result[i] += (XAUUSD_Slow*USDJPY_Slow) / (XAUUSD_Fast*USDJPY_Fast) - 1;                 
                         break;   
            case XAU :
                         if(Include[USD]) Result[i] += XAUUSD_Fast / XAUUSD_Slow - 1;
                         if(Include[EUR]) Result[i] += (EURUSD_Slow / XAUUSD_Slow) / (EURUSD_Fast / XAUUSD_Fast) - 1;
                         if(Include[GBP]) Result[i] += (GBPUSD_Slow / XAUUSD_Slow) / (GBPUSD_Fast / XAUUSD_Fast) - 1;
                         if(Include[NZD]) Result[i] += (XAUUSD_Fast/NZDUSD_Fast) / (XAUUSD_Slow / NZDUSD_Slow) - 1;
                         if(Include[CHF]) Result[i] += (XAUUSD_Fast*USDCHF_Fast) / (XAUUSD_Slow*USDCHF_Slow) - 1;
                         if(Include[CAD]) Result[i] += (XAUUSD_Fast*USDCAD_Fast) / (XAUUSD_Slow*USDCAD_Slow) - 1;
                         if(Include[JPY]) Result[i] += (XAUUSD_Fast*USDJPY_Fast) / (XAUUSD_Slow*USDJPY_Slow) - 1;
                         if(Include[AUD]) Result[i] += (XAUUSD_Fast/AUDUSD_Fast) / (XAUUSD_Slow / AUDUSD_Slow) - 1;                 
                         break; 
           }//END SWITCH
      }//END FOR I                   
         
         
    Result[2] =  Result[0] - Result[1]; 
    Result[1] = -Result[1];  
    return(0);      
}                
//**************************************************************************************************
//|  Subroutines                                                     |
//**************************************************************************************************
double ma(string sym, int tf, int per, int Mode, int Price, int i)
  {
   double res = 0;
   int k = 1;
   int ma_shift = 0;
   switch(Period())
     {
       case 1:     res += iMA(sym, tf, per*k, ma_shift, Mode, Price, i); 
                   k += 5;
       case 5:     res += iMA(sym, tf, per*k, ma_shift, Mode, Price, i); 
                   k += 3;
       case 15:    res += iMA(sym, tf, per*k, ma_shift, Mode, Price, i); 
                   k += 2;
       case 30:    res += iMA(sym, tf, per*k, ma_shift, Mode, Price, i); 
                   k += 2;
       case 60:    res += iMA(sym, tf, per*k, ma_shift, Mode, Price, i); 
                   k += 4;
       case 240:   res += iMA(sym, tf, per*k, ma_shift, Mode, Price, i); 
                   k += 6;
       case 1440:  res += iMA(sym, tf, per*k, ma_shift, Mode, Price, i); 
                   k += 4;
       case 10080: res += iMA(sym, tf, per*k, ma_shift, Mode, Price, i); 
                   k +=4;
       case 43200: res += iMA(sym, tf, per*k, ma_shift, Mode, Price, i); 
     } 
   return(res);
  }   
//=====================================================================
      

